#!/bin/sh
# - Makes index for repositories in a single directory.
# - Makes static pages for each repository directory.
#
# NOTE, things to do manually (once) before running this script:
# - write clone url, for example "git://git.codemadness.org/dir" to the "url"
#   file for each repo.
# - write description in "description" file.
#
# Usage:
# - mkdir -p gphdir && cd gphdir
# - sh example_create.sh

# path must be absolute.
basedir="/src"
reposdir="/home/git"
curdir="$(pwd)"

# make index.
stagit-gopher-index -b "$basedir" "${reposdir}/"*/ > "${curdir}/index.gph"

# make files per repo.
for dir in "${reposdir}/"*/; do
	# strip .git suffix.
	r=$(basename "${dir}")
	d=$(basename "${dir}" ".git")
	printf "%s... " "${d}"

	mkdir -p "${curdir}/${d}"
	cd "${curdir}/${d}" || continue
	stagit-gopher -b "${basedir}/${d}" -c ".cache" "${reposdir}/${r}"

	# symlinks
	ln -sf log.gph index.gph

	echo "done"
done
