#!/bin/sh
reposdir="/home/git"
releasedir="/var/www/domains/src.adamsgaard.dk/releases"

mkdir -p "${releasedir}"

generate_tarball()
{
	while read -r t; do
		f="${releasedir}/${n}/${n}-$(echo "${t}" | tr '/' '_').tar.gz"
		if test -f "${f}"; then
			if test "${t}" = "master"; then
				if test "$(stat -f '%m' "${dir}")" -gt "$(stat -f '%m' "${f}")"; then
					rm -f "${f}"
				else
					continue
				fi
			else
				continue
			fi
		fi
		git archive \
			--format tar.gz \
			--prefix "${n}-${t}/" \
			-o "${f}" \
			-- \
			"${t}"
	done
}

for dir in "${reposdir}/"*/; do
	n="$(basename "$dir")"
	printf '%s...' "${n}"
	mkdir -p "${releasedir}/${n}"
	cd "${dir}"
	#git branch -l | sed 's/[\* ]* //' | generate_tarball
	echo master | generate_tarball
	git tag -l | generate_tarball
	printf 'done\n'
done
